Index: trunk/LMDZ.VENUS/libf/phyvenus/write_field_phy.F90
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/write_field_phy.F90	(revision 892)
+++ trunk/LMDZ.VENUS/libf/phyvenus/write_field_phy.F90	(revision 892)
@@ -0,0 +1,36 @@
+!
+! $Header$
+!
+MODULE write_field_phy
+
+  CONTAINS 
+ 
+    SUBROUTINE WriteField_phy(name,Field,ll)
+    USE dimphy
+    USE mod_phys_lmdz_para
+    USE mod_grid_phy_lmdz
+    USE Write_Field
+    
+    IMPLICIT NONE
+    include 'dimensions.h'
+    include 'paramet.h'
+
+    character(len=*)   :: name
+    INTEGER :: ll
+    real, dimension(klon_omp,ll) :: Field
+    real,save,allocatable :: Field_tmp(:,:)
+    real, dimension(klon_glo,ll):: New_Field
+    real, dimension(iim,jjp1,ll):: Field_2d
+
+    CALL Gather(Field,New_Field)
+!$OMP MASTER
+    IF (is_mpi_root) THEN	
+      CALL Grid1Dto2D_glo(New_Field,Field_2D)
+      CALL WriteField(name,Field_2d)
+    ENDIF
+!$OMP END MASTER
+
+  
+   END SUBROUTINE WriteField_phy
+ 
+ END MODULE write_field_phy
Index: trunk/LMDZ.VENUS/libf/phyvenus/write_histday.h
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/write_histday.h	(revision 888)
+++ trunk/LMDZ.VENUS/libf/phyvenus/write_histday.h	(revision 892)
@@ -3,77 +3,54 @@
 !
       IF (ok_journe) THEN
-c
-      ndex2d = 0
-      ndex3d = 0
-      zx_tmp_2d = 0.
-      zx_tmp_3d = 0.
-      zx_tmp_fi2d=0.
-      zx_tmp_fi3d=0.
 
-c
          zsto = dtime
          zout = dtime * REAL(ecrit_day)
          itau_w = itau_phy + itap
 
-c
 c-------------------------------------------------------
       IF(lev_histday.GE.1) THEN
-c
+
 ccccccccccccc 2D fields, basics
-c
-      i = NINT(zout/zsto)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pphis,zx_tmp_2d)
-      CALL histwrite(nid_day,"phis",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-C
-      i = NINT(zout/zsto)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
-      CALL histwrite(nid_day,"aire",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ftsol,zx_tmp_2d)
-      CALL histwrite(nid_day,"tsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      DO i = 1, klon
-         zx_tmp_fi2d(i) = paprs(i,1)
-      ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_day,"psol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ue,zx_tmp_2d)
-      CALL histwrite(nid_day,"ue",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ve,zx_tmp_2d)
-      CALL histwrite(nid_day,"ve",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_day,.false.,"phis",itau_w,pphis)
+      call histwrite_phy(nid_day,.false.,"aire",itau_w,airephy)
+      call histwrite_phy(nid_day,.false.,"tsol",itau_w,ftsol)
+      call histwrite_phy(nid_day,.false.,"psol",itau_w,paprs(:,1))
+c     call histwrite_phy(nid_day,.false.,"ue",itau_w,ue)
+c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
+c     call histwrite_phy(nid_day,.false.,"ve",itau_w,-1.*ve)
+c     call histwrite_phy(nid_day,.false.,"cdragh",itau_w,cdragh)
+c     call histwrite_phy(nid_day,.false.,"cdragm",itau_w,cdragm)
+
       ENDIF !lev_histday.GE.1
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.2) THEN
-c
+
 ccccccccccccc 3D fields, basics
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"temp",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
-      CALL histwrite(nid_day,"pres",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
-      CALL histwrite(nid_day,"geop",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitu",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitv",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
-      CALL histwrite(nid_day,"vitw",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_day,.false.,"temp",itau_w,t_seri)
+      call histwrite_phy(nid_day,.false.,"pres",itau_w,pplay)
+      call histwrite_phy(nid_day,.false.,"geop",itau_w,zphi)
+      call histwrite_phy(nid_day,.false.,"vitu",itau_w,u_seri)
+c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
+      call histwrite_phy(nid_day,.false.,"vitv",itau_w,-1.*v_seri)
+      call histwrite_phy(nid_day,.false.,"vitw",itau_w,omega)
+c en (m/s)/s      
+      call histwrite_phy(nid_day,.false.,"dudyn",itau_w,d_u_dyn)
+c en (m/s)/s      
+      call histwrite_phy(nid_day,.false.,"duvdf",itau_w,d_u_vdf)
+c     call histwrite_phy(nid_day,.false.,"mang",itau_w,mang)
+c     call histwrite_phy(nid_day,.false.,"Kz",itau_w,ycoefh)
+
+c plusieurs traceurs
+       IF (iflag_trac.eq.1) THEN
+         DO iq=1,nqmax
+       call histwrite_phy(nid_day,.false.,tname(iq),itau_w,qx(:,:,iq))
+         ENDDO
+       ENDIF
+
+      call histwrite_phy(nid_day,.false.,"tops",itau_w,topsw)
+
       ENDIF !lev_histday.GE.2
 c
@@ -82,138 +59,59 @@
 c
 cccccccccccccccccc  Radiative transfer
-c
+
 c 2D
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
-      CALL histwrite(nid_day,"tops",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
-      CALL histwrite(nid_day,"topl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
-      CALL histwrite(nid_day,"sols",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
-      CALL histwrite(nid_day,"soll",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_day,.false.,"topl",itau_w,toplw)
+      call histwrite_phy(nid_day,.false.,"sols",itau_w,solsw)
+      call histwrite_phy(nid_day,.false.,"soll",itau_w,sollw)
+
 c 3D
-c
-      zx_tmp_fi3d(1:klon,1:klev)=swnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"SWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=lwnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"LWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_day,.false.,"SWnet",itau_w,swnet)
+      call histwrite_phy(nid_day,.false.,"LWnet",itau_w,lwnet)
+c     call histwrite_phy(nid_day,.false.,"fluxvdf",itau_w,fluxt)
+c     call histwrite_phy(nid_day,.false.,"fluxdyn",itau_w,flux_dyn)
+c     call histwrite_phy(nid_day,.false.,"fluxajs",itau_w,flux_ajs)
+c     call histwrite_phy(nid_day,.false.,"fluxec",itau_w,flux_ec)
+
       ENDIF !lev_histday.GE.3
 c
 c-------------------------------------------------------
       IF(lev_histday.GE.4) THEN
-c
+
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t_dyn, zx_tmp_3d)
-      CALL histwrite(nid_day,"dtdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtdyn",itau_w,d_t_dyn)
 c en K/s      
-c      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t, zx_tmp_3d)
-c      CALL histwrite(nid_day,"dtphy",itau_w,zx_tmp_3d,
-c     .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_day,.false.,"dtphy",itau_w,d_t)
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_t_vdf,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtvdf",itau_w,d_t_vdf)
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_t_ajs,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtajs",itau_w,d_t_ajs)
 c K/day ==> K/s
-      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY 
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtswr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dtswr",itau_w,heat/RDAY)
 c K/day ==> K/s      
-      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_day,"dtlwr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+      call histwrite_phy(nid_day,.false.,"dtlwr",itau_w,-1.*cool/RDAY)
 c en K/s      
-c     zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_day,"dtec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_day,.false.,"dtec",itau_w,d_t_ec)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_dyn, zx_tmp_3d)
-      CALL histwrite(nid_day,"dudyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"duajs",itau_w,d_u_ajs)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_vdf, zx_tmp_3d)
-      CALL histwrite(nid_day,"duvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dugwo",itau_w,d_u_oro)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_ajs, zx_tmp_3d)
-      CALL histwrite(nid_day,"duajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_day,.false.,"dugwno",itau_w,d_u_hin)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_oro, zx_tmp_3d)
-      CALL histwrite(nid_day,"dugwo",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_hin, zx_tmp_3d)
-      CALL histwrite(nid_day,"dugwno",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c en (m/s)/s      
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_v_vdf, zx_tmp_3d)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-c     zx_tmp_3d=-1.*zx_tmp_3d
-c     CALL histwrite(nid_day,"dvvdf",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_day,.false.,"dvvdf",itau_w,-1.*d_v_vdf)
+
       ENDIF !lev_histday.GE.4
 c
 c-------------------------------------------------------
       IF(lev_histday.GE.5) THEN
-c
-      IF (nqmax.GE.3) THEN
-        DO iq=1,nqmax-2
-         IF (iq.LE.99) THEN
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qx(1,1,iq+2), zx_tmp_3d)
-      WRITE(str2,'(i2.2)') iq
-      CALL histwrite(nid_day,"trac"//str2,itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-         ELSE
-      PRINT*, "Trop de traceurs"
-      CALL abort
-         ENDIF
-        ENDDO
-      ENDIF
-c
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxu , zx_tmp_2d)
-c      CALL histwrite(nid_day,"taux_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d) 
-c      
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxv , zx_tmp_2d)
-c      CALL histwrite(nid_day,"tauy_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-c     CALL histwrite(nid_day,"cdrm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-c     CALL histwrite(nid_day,"cdrh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+c     call histwrite_phy(nid_day,.false.,"taux_",itau_w,fluxu)
+c     call histwrite_phy(nid_day,.false.,"tauy_",itau_w,fluxv)
+c     call histwrite_phy(nid_day,.false.,"cdrm",itau_w,cdragm)
+c     call histwrite_phy(nid_day,.false.,"cdrh",itau_w,cdragh)
+
       ENDIF !lev_histday.GE.5
 c-------------------------------------------------------
Index: trunk/LMDZ.VENUS/libf/phyvenus/write_histins.h
===================================================================
--- trunk/LMDZ.VENUS/libf/phyvenus/write_histins.h	(revision 888)
+++ trunk/LMDZ.VENUS/libf/phyvenus/write_histins.h	(revision 892)
@@ -3,261 +3,121 @@
 !
       IF (ok_instan) THEN
-c
-      ndex2d = 0
-      ndex3d = 0
-      zx_tmp_2d = 0.
-      zx_tmp_3d = 0.
-      zx_tmp_fi2d=0.
-      zx_tmp_fi3d=0.
-c
+
          zsto = dtime * ecrit_ins
          zout = dtime * ecrit_ins
          itau_w = itau_phy + itap
 
-c
 c-------------------------------------------------------
       IF(lev_histday.GE.1) THEN
-c
+
 ccccccccccccc 2D fields, basics
-c
-      i = NINT(zout/zsto)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,pphis,zx_tmp_2d)
-      CALL histwrite(nid_ins,"phis",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-C
-      i = NINT(zout/zsto)
-      CALL gr_fi_ecrit(1,klon,iim,jjmp1,airephy,zx_tmp_2d)
-      CALL histwrite(nid_ins,"aire",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, ftsol,zx_tmp_2d)
-      CALL histwrite(nid_ins,"tsol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      DO i = 1, klon
-         zx_tmp_fi2d(i) = paprs(i,1)
-      ENDDO
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, zx_tmp_fi2d,zx_tmp_2d)
-      CALL histwrite(nid_ins,"psol",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ue,zx_tmp_2d)
-c     CALL histwrite(nid_ins,"ue",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, ve,zx_tmp_2d)
+
+      call histwrite_phy(nid_ins,.false.,"phis",itau_w,pphis)
+      call histwrite_phy(nid_ins,.false.,"aire",itau_w,airephy)
+      call histwrite_phy(nid_ins,.false.,"tsol",itau_w,ftsol)
+      call histwrite_phy(nid_ins,.false.,"psol",itau_w,paprs(:,1))
+c     call histwrite_phy(nid_ins,.false.,"ue",itau_w,ue)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-c     zx_tmp_2d=-1.*zx_tmp_2d
-c     CALL histwrite(nid_ins,"ve",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-      CALL histwrite(nid_ins,"cdragh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-      CALL histwrite(nid_ins,"cdragm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+c     call histwrite_phy(nid_ins,.false.,"ve",itau_w,-1.*ve)
+c     call histwrite_phy(nid_ins,.false.,"cdragh",itau_w,cdragh)
+c     call histwrite_phy(nid_ins,.false.,"cdragm",itau_w,cdragm)
+
       ENDIF !lev_histday.GE.1
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.2) THEN
-c
+
 ccccccccccccc 3D fields, basics
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, t_seri, zx_tmp_3d)
-      CALL histwrite(nid_ins,"temp",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, pplay, zx_tmp_3d)
-      CALL histwrite(nid_ins,"pres",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, zphi, zx_tmp_3d)
-      CALL histwrite(nid_ins,"geop",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, u_seri, zx_tmp_3d)
-      CALL histwrite(nid_ins,"vitu",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, v_seri, zx_tmp_3d)
+
+      call histwrite_phy(nid_ins,.false.,"temp",itau_w,t_seri)
+      call histwrite_phy(nid_ins,.false.,"pres",itau_w,pplay)
+      call histwrite_phy(nid_ins,.false.,"geop",itau_w,zphi)
+      call histwrite_phy(nid_ins,.false.,"vitu",itau_w,u_seri)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-      zx_tmp_3d=-1.*zx_tmp_3d
-      CALL histwrite(nid_ins,"vitv",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, omega, zx_tmp_3d)
-      CALL histwrite(nid_ins,"vitw",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"vitv",itau_w,-1.*v_seri)
+      call histwrite_phy(nid_ins,.false.,"vitw",itau_w,omega)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_dyn, zx_tmp_3d)
-      CALL histwrite(nid_ins,"dudyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dudyn",itau_w,d_u_dyn)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_vdf, zx_tmp_3d)
-      CALL histwrite(nid_ins,"duvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, mang, zx_tmp_3d)
-c     CALL histwrite(nid_ins,"mang",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, ycoefh, zx_tmp_3d)
-      CALL histwrite(nid_ins,"Kz",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"duvdf",itau_w,d_u_vdf)
+c     call histwrite_phy(nid_ins,.false.,"mang",itau_w,mang)
+c     call histwrite_phy(nid_ins,.false.,"Kz",itau_w,ycoefh)
+
 c plusieurs traceurs
        IF (iflag_trac.eq.1) THEN
          DO iq=1,nqmax
-          IF (iq.LE.99) THEN
-       CALL gr_fi_ecrit(klev,klon,iim,jjmp1, qx(1,1,iq), zx_tmp_3d)
-       WRITE(str2,'(i2.2)') iq
-       CALL histwrite(nid_ins,tname(iq),itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-          ELSE
-       PRINT*, "Trop de traceurs"
-       CALL abort
-          ENDIF
+       call histwrite_phy(nid_ins,.false.,tname(iq),itau_w,qx(:,:,iq))
          ENDDO
        ENDIF
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, topsw,zx_tmp_2d)
-      CALL histwrite(nid_ins,"tops",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_ins,.false.,"tops",itau_w,topsw)
+
       ENDIF !lev_histday.GE.2
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.3) THEN
-c
+
 cccccccccccccccccc  Radiative transfer
-c
+
 c 2D
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, toplw,zx_tmp_2d)
-      CALL histwrite(nid_ins,"topl",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, solsw,zx_tmp_2d)
-      CALL histwrite(nid_ins,"sols",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-      CALL gr_fi_ecrit(1, klon,iim,jjmp1, sollw,zx_tmp_2d)
-      CALL histwrite(nid_ins,"soll",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+      call histwrite_phy(nid_ins,.false.,"topl",itau_w,toplw)
+      call histwrite_phy(nid_ins,.false.,"sols",itau_w,solsw)
+      call histwrite_phy(nid_ins,.false.,"soll",itau_w,sollw)
+
 c 3D
-c
-      zx_tmp_fi3d(1:klon,1:klev)=swnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"SWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=lwnet(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"LWnet",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=fluxt(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"fluxvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=flux_dyn(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"fluxdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-      zx_tmp_fi3d(1:klon,1:klev)=flux_ajs(1:klon,1:klev)
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"fluxajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
-c     zx_tmp_fi3d(1:klon,1:klev)=flux_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_ins,"fluxec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+
+      call histwrite_phy(nid_ins,.false.,"SWnet",itau_w,swnet)
+      call histwrite_phy(nid_ins,.false.,"LWnet",itau_w,lwnet)
+c     call histwrite_phy(nid_ins,.false.,"fluxvdf",itau_w,fluxt)
+c     call histwrite_phy(nid_ins,.false.,"fluxdyn",itau_w,flux_dyn)
+c     call histwrite_phy(nid_ins,.false.,"fluxajs",itau_w,flux_ajs)
+c     call histwrite_phy(nid_ins,.false.,"fluxec",itau_w,flux_ec)
+
       ENDIF !lev_histday.GE.3
-c
+
 c-------------------------------------------------------
       IF(lev_histday.GE.4) THEN
-c
+
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t_dyn, zx_tmp_3d)
-      CALL histwrite(nid_ins,"dtdyn",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dtdyn",itau_w,d_t_dyn)
 c en K/s      
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_t, zx_tmp_3d)
-c     CALL histwrite(nid_ins,"dtphy",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_ins,.false.,"dtphy",itau_w,d_t)
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_t_vdf,zx_tmp_3d)
-      CALL histwrite(nid_ins,"dtvdf",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dtvdf",itau_w,d_t_vdf)
 c en K/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,d_t_ajs,zx_tmp_3d)
-      CALL histwrite(nid_ins,"dtajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dtajs",itau_w,d_t_ajs)
 c K/day ==> K/s
-      zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY 
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"dtswr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dtswr",itau_w,heat/RDAY)
 c K/day ==> K/s      
-      zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-      CALL histwrite(nid_ins,"dtlwr",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
+      call histwrite_phy(nid_ins,.false.,"dtlwr",itau_w,-1.*cool/RDAY)
 c en K/s      
-c     zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1,zx_tmp_fi3d,zx_tmp_3d)
-c     CALL histwrite(nid_ins,"dtec",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_ins,.false.,"dtec",itau_w,d_t_ec)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_ajs, zx_tmp_3d)
-      CALL histwrite(nid_ins,"duajs",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"duajs",itau_w,d_u_ajs)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_oro, zx_tmp_3d)
-      CALL histwrite(nid_ins,"dugwo",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dugwo",itau_w,d_u_oro)
 c en (m/s)/s      
-      CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_u_hin, zx_tmp_3d)
-      CALL histwrite(nid_ins,"dugwno",itau_w,zx_tmp_3d,
-     .                                   iim*jjmp1*klev,ndex3d)
-c
+      call histwrite_phy(nid_ins,.false.,"dugwno",itau_w,d_u_hin)
 c en (m/s)/s      
-c     CALL gr_fi_ecrit(klev,klon,iim,jjmp1, d_v_vdf, zx_tmp_3d)
 c VENUS: regardee a l'envers!!!!!!!!!!!!!!!
-c     zx_tmp_3d=-1.*zx_tmp_3d
-c     CALL histwrite(nid_ins,"dvvdf",itau_w,zx_tmp_3d,
-c    .                                   iim*jjmp1*klev,ndex3d)
-c
+c     call histwrite_phy(nid_ins,.false.,"dvvdf",itau_w,-1.*d_v_vdf)
+
       ENDIF !lev_histday.GE.4
-c
+
 c-------------------------------------------------------
        IF(lev_histday.GE.5) THEN
-c
-c
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxu , zx_tmp_2d)
-c      CALL histwrite(nid_ins,"taux_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d) 
-c      
-c      CALL gr_fi_ecrit(1, klon,iim,jjmp1, fluxv , zx_tmp_2d)
-c      CALL histwrite(nid_ins,"tauy_",itau_w,
-c    $      zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragm,zx_tmp_2d)
-c     CALL histwrite(nid_ins,"cdrm",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
-c     CALL gr_fi_ecrit(1, klon,iim,jjmp1, cdragh,zx_tmp_2d)
-c     CALL histwrite(nid_ins,"cdrh",itau_w,zx_tmp_2d,iim*jjmp1,ndex2d)
-c
+
+c     call histwrite_phy(nid_ins,.false.,"taux_",itau_w,fluxu)
+c     call histwrite_phy(nid_ins,.false.,"tauy_",itau_w,fluxv)
+c     call histwrite_phy(nid_ins,.false.,"cdrm",itau_w,cdragm)
+c     call histwrite_phy(nid_ins,.false.,"cdrh",itau_w,cdragh)
+
       ENDIF !lev_histday.GE.5
 c-------------------------------------------------------
-c
+
       if (ok_sync) then
         call histsync(nid_ins)
       endif
+
       ENDIF
